package com.cpp.web.controller.accuracy;

import com.cpp.common.core.domain.R;
import com.cpp.web.domain.accuracy.AccuracyPassRate;
import com.cpp.web.domain.enums.DataSourcesEnum;
import com.cpp.web.domain.enums.ForecastTypeEnum;
import com.cpp.web.service.accuracy.AccuracyPassRateService;
import lombok.RequiredArgsConstructor;
import org.springframework.web.bind.annotation.*;

import java.util.Date;
import java.util.List;
import java.util.Map;

@RestController
@RequiredArgsConstructor
@RequestMapping("accuracyPassRate")
public class AccuracyPassRateController {
    private final AccuracyPassRateService accuracyPassRateService;

    @GetMapping("/getByTimeBetweenAndForecastTypeAndDataSourcesAndForecastModelAndStationCode")
    public R getByTimeBetweenAndForecastTypeAndDataSourcesAndForecastModelAndStationCode(Long startTime, Long endTime, ForecastTypeEnum forecastType, DataSourcesEnum dataSources,Integer ago, String forecastModel, String stationCode){
        List<AccuracyPassRate> accuracyPassRateList = accuracyPassRateService.findByTimeBetweenAndForecastTypeAndDataSourcesAndAgoAndForecastModelAndStationCode(new Date(startTime),new Date(endTime),forecastType,dataSources,ago,forecastModel,stationCode);
        return R.ok(accuracyPassRateList);
    }

    @GetMapping("/getByMonthBetweenAndForecastTypeAndStationCode")
    public R getByMonthBetweenAndForecastTypeAndStationCode(Long startTime,Long endTime,ForecastTypeEnum forecastType, DataSourcesEnum dataSources, String stationCode){
        Map<String, Double> map = accuracyPassRateService.findByMonthBetweenAndForecastTypeAndStationCode(startTime,endTime,forecastType,dataSources,stationCode);
        return R.ok(map);
    }
    @GetMapping("/getBySingleMonthBetweenAndForecastTypeAndStationCode")
    public R getBySingleMonthBetweenAndForecastTypeAndStationCode(Long startTime,Long endTime,ForecastTypeEnum forecastType, DataSourcesEnum dataSources, String stationCode,String stationName,String uploadDataSources){
        List<Map<String,String>> accuracyPassRateList = accuracyPassRateService.finfBySingleMonthBetweenAndForecastTypeAndStationCode(startTime,endTime,forecastType,dataSources,stationCode,stationName,uploadDataSources);
        return R.ok(accuracyPassRateList);
    }
}
